diff --git a/dlls/dinput/effect_linuxinput.c b/dlls/dinput/effect_linuxinput.c
index d5daba6daa1..640b527c4e2 100644
--- a/dlls/dinput/effect_linuxinput.c
+++ b/dlls/dinput/effect_linuxinput.c
@@ -47,24 +47,23 @@
 
 WINE_DEFAULT_DEBUG_CHANNEL(dinput);
 
-static const IDirectInputEffectVtbl LinuxInputEffectVtbl;
 typedef struct LinuxInputEffectImpl LinuxInputEffectImpl;
 struct LinuxInputEffectImpl
 {
-    IDirectInputEffect  IDirectInputEffect_iface;
-    LONG                ref;
-    GUID                guid;
-
+    DWORD               type;
     struct ff_effect    effect; /* Effect data */
     int                 gain;   /* Effect gain */
     BOOL                first_axis_is_x;
     int*                fd;     /* Parent device */
-    struct list        *entry;  /* Entry into the parent's list of effects */
 };
 
-static inline LinuxInputEffectImpl *impl_from_IDirectInputEffect(IDirectInputEffect *iface)
+static inline LinuxInputEffectImpl *impl_from_unix_effect(struct unix_effect *ptr)
+{
+    return (LinuxInputEffectImpl *)ptr;
+}
+static inline struct unix_effect *unix_effect_from_impl(LinuxInputEffectImpl *This)
 {
-    return CONTAINING_RECORD(iface, LinuxInputEffectImpl, IDirectInputEffect_iface);
+    return (struct unix_effect *)This;
 }
 
 static double ff_effect_direction_to_rad(unsigned int dir)
@@ -163,19 +162,9 @@ static void ff_dump_effect(struct ff_effect *effect)
  *      LinuxInputEffectImpl 
  */
 
-static ULONG WINAPI LinuxInputEffectImpl_AddRef(
-	LPDIRECTINPUTEFFECT iface)
+static HRESULT CDECL unix_effect_download(struct unix_effect *ptr)
 {
-    LinuxInputEffectImpl *This = impl_from_IDirectInputEffect(iface);
-    ULONG ref = InterlockedIncrement(&This->ref);
-    TRACE( "(%p) ref %d\n", This, ref );
-    return ref;
-}
-
-static HRESULT WINAPI LinuxInputEffectImpl_Download(
-	LPDIRECTINPUTEFFECT iface)
-{
-    LinuxInputEffectImpl *This = impl_from_IDirectInputEffect(iface);
+    LinuxInputEffectImpl *This = impl_from_unix_effect(ptr);
     int ret, old_effect_id;
 
     TRACE("(this=%p)\n", This);
@@ -209,34 +198,17 @@ static HRESULT WINAPI LinuxInputEffectImpl_Download(
     return ret;
 }
 
-static HRESULT WINAPI LinuxInputEffectImpl_Escape(
-	LPDIRECTINPUTEFFECT iface,
-        LPDIEFFESCAPE pesc)
+static HRESULT CDECL unix_effect_escape(struct unix_effect *ptr, LPDIEFFESCAPE pesc)
 {
     WARN("(this=%p,%p): invalid: no hardware-specific escape codes in this" 
-         " driver!\n", iface, pesc);
-
-    return DI_OK;
-}
-
-static HRESULT WINAPI LinuxInputEffectImpl_GetEffectGuid(
-        LPDIRECTINPUTEFFECT iface,
-	LPGUID pguid)
-{
-    LinuxInputEffectImpl *This = impl_from_IDirectInputEffect(iface);
-
-    TRACE("(this=%p,%p)\n", This, pguid);
-
-    *pguid = This->guid;
+         " driver!\n", ptr, pesc);
 
     return DI_OK;
 }
 
-static HRESULT WINAPI LinuxInputEffectImpl_GetEffectStatus(
-        LPDIRECTINPUTEFFECT iface,
-	LPDWORD pdwFlags)
+static HRESULT CDECL unix_effect_get_status(struct unix_effect *ptr, LPDWORD pdwFlags)
 {
-    LinuxInputEffectImpl *This = impl_from_IDirectInputEffect(iface);
+    LinuxInputEffectImpl *This = impl_from_unix_effect(ptr);
 
     TRACE("(this=%p,%p)\n", This, pdwFlags);
 
@@ -256,13 +228,10 @@ static HRESULT WINAPI LinuxInputEffectImpl_GetEffectStatus(
     return DI_OK;
 }
 
-static HRESULT WINAPI LinuxInputEffectImpl_GetParameters(
-	LPDIRECTINPUTEFFECT iface,
-	LPDIEFFECT peff,
-	DWORD dwFlags)
+static HRESULT CDECL unix_effect_get_parameters(struct unix_effect *ptr, LPDIEFFECT peff, DWORD dwFlags)
 {
     HRESULT diErr = DI_OK;
-    LinuxInputEffectImpl *This = impl_from_IDirectInputEffect(iface);
+    LinuxInputEffectImpl *This = impl_from_unix_effect(ptr);
     TRACE("(this=%p,%p,%d)\n", This, peff, dwFlags);
 
     /* Major conversion factors are:
@@ -412,55 +381,19 @@ static HRESULT WINAPI LinuxInputEffectImpl_GetParameters(
     return diErr;
 }
 
-static HRESULT WINAPI LinuxInputEffectImpl_Initialize(
-        LPDIRECTINPUTEFFECT iface,
-	HINSTANCE hinst,
-	DWORD dwVersion,
-	REFGUID rguid)
-{
-    FIXME("(this=%p,%p,%d,%s): stub!\n",
-	 iface, hinst, dwVersion, debugstr_guid(rguid));
-
-    return DI_OK;
-}
-
-static HRESULT WINAPI LinuxInputEffectImpl_QueryInterface(
-	LPDIRECTINPUTEFFECT iface,
-	REFIID riid,
-	void **ppvObject)
-{
-    LinuxInputEffectImpl *This = impl_from_IDirectInputEffect(iface);
-
-    TRACE("(this=%p,%s,%p)\n", This, debugstr_guid(riid), ppvObject);
-
-    if (IsEqualGUID(&IID_IUnknown, riid) ||
-	IsEqualGUID(&IID_IDirectInputEffect, riid)) {
-	    LinuxInputEffectImpl_AddRef(iface);
-	    *ppvObject = This;
-	    return 0;
-    }
-
-    TRACE("Unsupported interface!\n");
-    return E_FAIL;
-}
-
-static HRESULT WINAPI LinuxInputEffectImpl_Start(
-	LPDIRECTINPUTEFFECT iface,
-	DWORD dwIterations,
-	DWORD dwFlags)
+static HRESULT CDECL unix_effect_start(struct unix_effect *ptr, DWORD dwIterations, DWORD dwFlags)
 {
     struct input_event event;
-    LinuxInputEffectImpl *This = impl_from_IDirectInputEffect(iface);
+    LinuxInputEffectImpl *This = impl_from_unix_effect(ptr);
 
     TRACE("(this=%p,%d,%d)\n", This, dwIterations, dwFlags);
 
     if (!(dwFlags & DIES_NODOWNLOAD)) {
 	/* Download the effect if necessary */
 	if (This->effect.id == -1) {
-	    HRESULT res = LinuxInputEffectImpl_Download(iface);
-	    if (res != DI_OK)
-		return res;
-	}
+            HRESULT res = unix_effect_download(ptr);
+            if (res != DI_OK) return res;
+        }
     }
 
     if (dwFlags & DIES_SOLO) {
@@ -478,19 +411,13 @@ static HRESULT WINAPI LinuxInputEffectImpl_Start(
     return DI_OK;
 }
 
-static HRESULT WINAPI LinuxInputEffectImpl_SetParameters(
-        LPDIRECTINPUTEFFECT iface,
-        LPCDIEFFECT peff,
-        DWORD dwFlags)
+static HRESULT CDECL unix_effect_set_parameters(struct unix_effect *ptr, LPCDIEFFECT peff, DWORD dwFlags)
 {
-    LinuxInputEffectImpl *This = impl_from_IDirectInputEffect(iface);
-    DWORD type = typeFromGUID(&This->guid);
+    LinuxInputEffectImpl *This = impl_from_unix_effect(ptr);
     HRESULT retval = DI_OK;
 
     TRACE("(this=%p,%p,%d)\n", This, peff, dwFlags);
 
-    dump_DIEFFECT(peff, &This->guid, dwFlags);
-
     if (!dwFlags)
         return DI_NOEFFECT;
 
@@ -633,7 +560,7 @@ static HRESULT WINAPI LinuxInputEffectImpl_SetParameters(
         if (!(peff->lpvTypeSpecificParams))
             return DIERR_INVALIDPARAM;
 
-        if (type == DIEFT_PERIODIC)
+        if (This->type == DIEFT_PERIODIC)
         {
             DIPERIODIC *tsp;
             if (peff->cbTypeSpecificParams != sizeof(DIPERIODIC))
@@ -650,14 +577,14 @@ static HRESULT WINAPI LinuxInputEffectImpl_SetParameters(
             else
                 This->effect.u.periodic.period = tsp->dwPeriod / 1000;
         }
-        else if (type == DIEFT_CONSTANTFORCE)
+        else if (This->type == DIEFT_CONSTANTFORCE)
         {
             LPCDICONSTANTFORCE tsp;
             if (peff->cbTypeSpecificParams != sizeof(DICONSTANTFORCE))
                 return DIERR_INVALIDPARAM;
             tsp = peff->lpvTypeSpecificParams;
 	    This->effect.u.constant.level = (max(min(tsp->lMagnitude, 10000), -10000) / 10) * 32;
-	} else if (type == DIEFT_RAMPFORCE) {
+	} else if (This->type == DIEFT_RAMPFORCE) {
             LPCDIRAMPFORCE tsp;
             if (peff->cbTypeSpecificParams != sizeof(DIRAMPFORCE))
                 return DIERR_INVALIDPARAM;
@@ -665,7 +592,7 @@ static HRESULT WINAPI LinuxInputEffectImpl_SetParameters(
 	    This->effect.u.ramp.start_level = (tsp->lStart / 10) * 32;
 	    This->effect.u.ramp.end_level = (tsp->lEnd / 10) * 32;
         }
-        else if (type == DIEFT_CONDITION)
+        else if (This->type == DIEFT_CONDITION)
         {
             DICONDITION *tsp = peff->lpvTypeSpecificParams;
             struct ff_condition_effect *cond = This->effect.u.condition;
@@ -709,27 +636,24 @@ static HRESULT WINAPI LinuxInputEffectImpl_SetParameters(
         }
     }
 
-    if (!(dwFlags & DIEP_NODOWNLOAD))
-	retval = LinuxInputEffectImpl_Download(iface);
+    if (!(dwFlags & DIEP_NODOWNLOAD)) retval = unix_effect_download(ptr);
     if (retval != DI_OK)
 	return DI_DOWNLOADSKIPPED;
 
     if (dwFlags & DIEP_NORESTART)
 	TRACE("DIEP_NORESTART: not handled (we have no control of that).\n");
 
-    if (dwFlags & DIEP_START)
-	retval = LinuxInputEffectImpl_Start(iface, 1, 0);
+    if (dwFlags & DIEP_START) retval = unix_effect_start(ptr, 1, 0);
     if (retval != DI_OK)
 	return retval;
  
     return DI_OK;
-}   
+}
 
-static HRESULT WINAPI LinuxInputEffectImpl_Stop(
-        LPDIRECTINPUTEFFECT iface)
+static HRESULT CDECL unix_effect_stop(struct unix_effect *ptr)
 {
     struct input_event event;
-    LinuxInputEffectImpl *This = impl_from_IDirectInputEffect(iface);
+    LinuxInputEffectImpl *This = impl_from_unix_effect(ptr);
 
     TRACE("(this=%p)\n", This);
 
@@ -742,10 +666,9 @@ static HRESULT WINAPI LinuxInputEffectImpl_Stop(
     return DI_OK;
 }
 
-static HRESULT WINAPI LinuxInputEffectImpl_Unload(
-	LPDIRECTINPUTEFFECT iface)
+static HRESULT CDECL unix_effect_unload(struct unix_effect *ptr)
 {
-    LinuxInputEffectImpl *This = impl_from_IDirectInputEffect(iface);
+    LinuxInputEffectImpl *This = impl_from_unix_effect(ptr);
     TRACE("(this=%p)\n", This);
 
     /* Erase the downloaded effect */
@@ -758,43 +681,56 @@ static HRESULT WINAPI LinuxInputEffectImpl_Unload(
     return DI_OK;
 }
 
-static ULONG WINAPI LinuxInputEffectImpl_Release(LPDIRECTINPUTEFFECT iface)
+static void CDECL unix_effect_destroy(struct unix_effect *ptr)
 {
-    LinuxInputEffectImpl *This = impl_from_IDirectInputEffect(iface);
-    ULONG ref = InterlockedDecrement(&(This->ref));
-
-    TRACE( "(%p) ref %d\n", This, ref );
-
-    if (ref == 0)
-    {
-        LinuxInputEffectImpl_Stop(iface);
-        LinuxInputEffectImpl_Unload(iface);
-        list_remove(This->entry);
-        HeapFree(GetProcessHeap(), 0, LIST_ENTRY(This->entry, effect_list_item, entry));
-        HeapFree(GetProcessHeap(), 0, This);
-    }
-    return ref;
+    unix_effect_stop(ptr);
+    unix_effect_unload(ptr);
+    HeapFree(GetProcessHeap(), 0, ptr);
 }
 
+static const struct unix_effect_vtbl unix_effect_vtbl =
+{
+    unix_effect_get_parameters,
+    unix_effect_set_parameters,
+    unix_effect_start,
+    unix_effect_stop,
+    unix_effect_get_status,
+    unix_effect_download,
+    unix_effect_unload,
+    unix_effect_escape,
+    unix_effect_destroy,
+};
+
 /******************************************************************************
  *      LinuxInputEffect
  */
 
-DECLSPEC_HIDDEN HRESULT linuxinput_create_effect(
-	int* fd,
-	REFGUID rguid,
-        struct list *parent_list_entry,
-	LPDIRECTINPUTEFFECT* peff)
+DECLSPEC_HIDDEN HRESULT linuxinput_create_effect(int *fd, REFGUID rguid, DWORD type, const DIEFFECT *effect, const struct unix_effect_vtbl **vtbl, struct unix_effect **out)
 {
-    LinuxInputEffectImpl* newEffect = HeapAlloc(GetProcessHeap(), 
-	HEAP_ZERO_MEMORY, sizeof(LinuxInputEffectImpl));
-    DWORD type = typeFromGUID(rguid);
+    LinuxInputEffectImpl *newEffect;
+    HRESULT hr;
+
+    switch (type)
+    {
+    case DIEFT_PERIODIC:
+    case DIEFT_CONSTANTFORCE:
+    case DIEFT_RAMPFORCE:
+    case DIEFT_CONDITION:
+        break;
+    case DIEFT_CUSTOMFORCE:
+        FIXME("Custom forces are not supported.\n");
+        return DIERR_INVALIDPARAM;
+    default:
+        FIXME("Unknown force type 0x%x.\n", type);
+        return DIERR_INVALIDPARAM;
+    }
+
+    if (!(newEffect = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(*newEffect))))
+        return DIERR_OUTOFMEMORY;
 
-    newEffect->IDirectInputEffect_iface.lpVtbl = &LinuxInputEffectVtbl;
-    newEffect->ref = 1;
-    newEffect->guid = *rguid;
     newEffect->fd = fd;
     newEffect->gain = 0xFFFF;
+    newEffect->type = type;
 
     /* set the type.  this cannot be changed over the effect's life. */
     switch (type) {
@@ -829,26 +765,27 @@ DECLSPEC_HIDDEN HRESULT linuxinput_create_effect(
 		newEffect->effect.type = FF_DAMPER;
 	    }
 	    break;
-	case DIEFT_CUSTOMFORCE:
-	    FIXME("Custom forces are not supported.\n");
-	    HeapFree(GetProcessHeap(), 0, newEffect);
-	    return DIERR_INVALIDPARAM;
 	default:
-            FIXME("Unknown force type 0x%x.\n", type);
-            HeapFree(GetProcessHeap(), 0, newEffect);
-	    return DIERR_INVALIDPARAM;
+            break;
     }
 
     /* mark as non-uploaded */
     newEffect->effect.id = -1;
 
-    newEffect->entry = parent_list_entry;
-
-    *peff = &newEffect->IDirectInputEffect_iface;
+    hr = unix_effect_set_parameters(unix_effect_from_impl(newEffect), effect,
+            DIEP_AXES | DIEP_DIRECTION | DIEP_DURATION | DIEP_ENVELOPE | DIEP_GAIN | DIEP_SAMPLEPERIOD |
+            DIEP_STARTDELAY | DIEP_TRIGGERBUTTON | DIEP_TRIGGERREPEATINTERVAL | DIEP_TYPESPECIFICPARAMS);
+    if (hr != DI_OK && hr != DI_DOWNLOADSKIPPED)
+    {
+        HeapFree(GetProcessHeap(), 0, newEffect);
+        return hr;
+    }
 
     TRACE("Creating linux input system effect (%p) with guid %s\n", 
-	  *peff, _dump_dinput_GUID(rguid));
+	  newEffect, _dump_dinput_GUID(rguid));
 
+    *vtbl = &unix_effect_vtbl;
+    *out = unix_effect_from_impl(newEffect);
     return DI_OK;
 }
 
@@ -886,20 +823,4 @@ DECLSPEC_HIDDEN HRESULT linuxinput_get_info_A(
     return DI_OK;
 }
 
-static const IDirectInputEffectVtbl LinuxInputEffectVtbl = {
-    LinuxInputEffectImpl_QueryInterface,
-    LinuxInputEffectImpl_AddRef,
-    LinuxInputEffectImpl_Release,
-    LinuxInputEffectImpl_Initialize,
-    LinuxInputEffectImpl_GetEffectGuid,
-    LinuxInputEffectImpl_GetParameters,
-    LinuxInputEffectImpl_SetParameters,
-    LinuxInputEffectImpl_Start,
-    LinuxInputEffectImpl_Stop,
-    LinuxInputEffectImpl_GetEffectStatus,
-    LinuxInputEffectImpl_Download,
-    LinuxInputEffectImpl_Unload,
-    LinuxInputEffectImpl_Escape
-};
-
 #endif /* HAVE_STRUCT_FF_EFFECT_DIRECTION */
diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index f226fa944e7..6768ff5b1be 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -61,6 +61,167 @@ const GUID DInput_PIDVID_Product_GUID = { /* device_pidvid-0000-0000-0000-504944
     0x00000000, 0x0000, 0x0000, {0x00, 0x00, 0x50, 0x49, 0x44, 0x56, 0x49, 0x44}
 };
 
+static void dump_DIEFFECT(LPCDIEFFECT eff, REFGUID guid, DWORD dwFlags);
+
+struct dinput_unix_effect
+{
+    IDirectInputEffect IDirectInputEffect_iface;
+    LONG ref;
+    GUID guid;
+    const struct unix_effect_vtbl *unix_funcs;
+    struct unix_effect *unix_ptr;
+    struct list entry;
+};
+
+static inline struct dinput_unix_effect *impl_from_IDirectInputEffect(IDirectInputEffect *iface)
+{
+    return CONTAINING_RECORD(iface, struct dinput_unix_effect, IDirectInputEffect_iface);
+}
+
+static inline IDirectInputEffect *IDirectInputEffect_from_impl(struct dinput_unix_effect *This)
+{
+    return &This->IDirectInputEffect_iface;
+}
+
+static HRESULT STDMETHODCALLTYPE dinput_unix_effect_QueryInterface(IDirectInputEffect *iface, REFIID iid, void **out)
+{
+    struct dinput_unix_effect *This = impl_from_IDirectInputEffect(iface);
+    TRACE("iface %p, iid %s, out %p.\n", iface, debugstr_guid(iid), out);
+
+    if (IsEqualGUID(&IID_IUnknown, iid) || IsEqualGUID(&IID_IDirectInputEffect, iid))
+    {
+        IDirectInputEffect_AddRef(iface);
+        *out = This;
+        return 0;
+    }
+
+    FIXME("Unsupported interface %s!\n", debugstr_guid(iid));
+    return E_FAIL;
+}
+
+static ULONG STDMETHODCALLTYPE dinput_unix_effect_AddRef(IDirectInputEffect *iface)
+{
+    struct dinput_unix_effect *This = impl_from_IDirectInputEffect(iface);
+    ULONG ref = InterlockedIncrement(&This->ref);
+    TRACE("iface %p -> ref %d.\n", iface, ref);
+    return ref;
+}
+
+static ULONG STDMETHODCALLTYPE dinput_unix_effect_Release(IDirectInputEffect *iface)
+{
+    struct dinput_unix_effect *This = impl_from_IDirectInputEffect(iface);
+    ULONG ref = InterlockedDecrement(&(This->ref));
+    TRACE("iface %p -> ref %d\n", iface, ref);
+    if (ref) return ref;
+    This->unix_funcs->destroy(This->unix_ptr);
+    list_remove(&This->entry);
+    HeapFree(GetProcessHeap(), 0, This);
+    return 0;
+}
+
+static HRESULT STDMETHODCALLTYPE dinput_unix_effect_Initialize(IDirectInputEffect *iface, HINSTANCE instance, DWORD version, REFGUID guid)
+{
+    TRACE("iface %p, instance %p, version %#x, guid %s, stub!\n", iface, instance, version, debugstr_guid(guid));
+    return DI_OK;
+}
+
+static HRESULT STDMETHODCALLTYPE dinput_unix_effect_GetEffectGuid(IDirectInputEffect *iface, GUID *guid)
+{
+    struct dinput_unix_effect *This = impl_from_IDirectInputEffect(iface);
+    TRACE("iface %p, guid %p.\n", iface, guid);
+    *guid = This->guid;
+    return DI_OK;
+}
+
+static HRESULT STDMETHODCALLTYPE dinput_unix_effect_GetParameters(IDirectInputEffect *iface, DIEFFECT *effect, DWORD flags)
+{
+    struct dinput_unix_effect *This = impl_from_IDirectInputEffect(iface);
+    TRACE("iface %p, effect %p, flags %#x.\n", iface, effect, flags);
+    return This->unix_funcs->get_parameters(This->unix_ptr, effect, flags);
+}
+
+static HRESULT STDMETHODCALLTYPE dinput_unix_effect_SetParameters(IDirectInputEffect *iface, const DIEFFECT *effect, DWORD flags)
+{
+    struct dinput_unix_effect *This = impl_from_IDirectInputEffect(iface);
+    TRACE("iface %p, effect %p, flags %#x.\n", iface, effect, flags);
+    dump_DIEFFECT(effect, &This->guid, flags);
+    return This->unix_funcs->set_parameters(This->unix_ptr, effect, flags);
+}
+
+static HRESULT STDMETHODCALLTYPE dinput_unix_effect_Start(IDirectInputEffect *iface, DWORD iterations, DWORD flags)
+{
+    struct dinput_unix_effect *This = impl_from_IDirectInputEffect(iface);
+    TRACE("iface %p, iterations %u, flags %#x.\n", iface, iterations, flags);
+    return This->unix_funcs->start(This->unix_ptr, iterations, flags);
+}
+
+static HRESULT STDMETHODCALLTYPE dinput_unix_effect_Stop(IDirectInputEffect *iface)
+{
+    struct dinput_unix_effect *This = impl_from_IDirectInputEffect(iface);
+    TRACE("iface %p.\n", iface);
+    return This->unix_funcs->stop(This->unix_ptr);
+}
+
+static HRESULT STDMETHODCALLTYPE dinput_unix_effect_GetEffectStatus(IDirectInputEffect *iface, DWORD *flags)
+{
+    struct dinput_unix_effect *This = impl_from_IDirectInputEffect(iface);
+    TRACE("iface %p, flags %p.\n", iface, flags);
+    return This->unix_funcs->get_status(This->unix_ptr, flags);
+}
+
+static HRESULT STDMETHODCALLTYPE dinput_unix_effect_Download(IDirectInputEffect *iface)
+{
+    struct dinput_unix_effect *This = impl_from_IDirectInputEffect(iface);
+    TRACE("iface %p.\n", iface);
+    return This->unix_funcs->download(This->unix_ptr);
+}
+
+static HRESULT STDMETHODCALLTYPE dinput_unix_effect_Unload(IDirectInputEffect *iface)
+{
+    struct dinput_unix_effect *This = impl_from_IDirectInputEffect(iface);
+    TRACE("iface %p.\n", iface);
+    return This->unix_funcs->unload(This->unix_ptr);
+}
+
+static HRESULT STDMETHODCALLTYPE dinput_unix_effect_Escape(IDirectInputEffect *iface, DIEFFESCAPE *escape)
+{
+    struct dinput_unix_effect *This = impl_from_IDirectInputEffect(iface);
+    TRACE("iface %p, escape %p.\n", iface, escape);
+    return This->unix_funcs->escape(This->unix_ptr, escape);
+}
+
+static const IDirectInputEffectVtbl dinput_unix_effect_vtbl =
+{
+    /*** IUnknown methods ***/
+    dinput_unix_effect_QueryInterface,
+    dinput_unix_effect_AddRef,
+    dinput_unix_effect_Release,
+    /*** IDirectInputEffect methods ***/
+    dinput_unix_effect_Initialize,
+    dinput_unix_effect_GetEffectGuid,
+    dinput_unix_effect_GetParameters,
+    dinput_unix_effect_SetParameters,
+    dinput_unix_effect_Start,
+    dinput_unix_effect_Stop,
+    dinput_unix_effect_GetEffectStatus,
+    dinput_unix_effect_Download,
+    dinput_unix_effect_Unload,
+    dinput_unix_effect_Escape,
+};
+
+static HRESULT CDECL dinput_unix_effect_alloc(const struct unix_effect_vtbl *unix_funcs, struct unix_effect *unix_ptr, const GUID *guid, IDirectInputEffect **out)
+{
+    struct dinput_unix_effect *This;
+    if (!(This = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(*This)))) return DIERR_OUTOFMEMORY;
+    This->IDirectInputEffect_iface.lpVtbl = &dinput_unix_effect_vtbl;
+    This->ref = 1;
+    This->guid = *guid;
+    This->unix_funcs = unix_funcs;
+    This->unix_ptr = unix_ptr;
+    *out = &This->IDirectInputEffect_iface;
+    return DI_OK;
+}
+
 static inline JoystickGenericImpl *impl_from_IDirectInputDevice8W(IDirectInputDevice8W *iface)
 {
     return CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8W_iface), JoystickGenericImpl, base);
@@ -178,7 +339,7 @@ static void _dump_DICUSTOMFORCE(LPCDICUSTOMFORCE frc)
     }
 }
 
-void dump_DIEFFECT(LPCDIEFFECT eff, REFGUID guid, DWORD dwFlags)
+static void dump_DIEFFECT(LPCDIEFFECT eff, REFGUID guid, DWORD dwFlags)
 {
     DWORD type = typeFromGUID(guid);
     unsigned int i;
@@ -799,7 +960,9 @@ HRESULT WINAPI JoystickWGenericImpl_CreateEffect(LPDIRECTINPUTDEVICE8W iface, RE
         LPDIRECTINPUTEFFECT *ppdef, LPUNKNOWN pUnkOuter)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
-    effect_list_item *item = NULL;
+    struct dinput_unix_effect *unix_effect;
+    const struct unix_effect_vtbl *unix_vtbl;
+    struct unix_effect *unix_ptr = NULL;
     HRESULT hr;
 
     TRACE("(this=%p,%p,%p,%p,%p)\n", This, rguid, lpeff, ppdef, pUnkOuter);
@@ -807,15 +970,18 @@ HRESULT WINAPI JoystickWGenericImpl_CreateEffect(LPDIRECTINPUTDEVICE8W iface, RE
     if (!ppdef) return E_POINTER;
     *ppdef = NULL;
 
+    dump_DIEFFECT(lpeff, rguid, 0);
+
     if (!This->unix_funcs->create_effect) return DIERR_UNSUPPORTED;
-    if (!(item = HeapAlloc(GetProcessHeap(), 0, sizeof(*item)))) return DIERR_OUTOFMEMORY;
-    if (FAILED(hr = This->unix_funcs->create_effect(This->unix_ptr, rguid, lpeff, &item->entry, &item->ref)))
+    if (FAILED(hr = This->unix_funcs->create_effect(This->unix_ptr, rguid, typeFromGUID(rguid), lpeff, &unix_vtbl, &unix_ptr)) ||
+        FAILED(hr = dinput_unix_effect_alloc(unix_vtbl, unix_ptr, rguid, ppdef)))
     {
-        HeapFree(GetProcessHeap(), 0, item);
+        if (*ppdef) IDirectInputEffect_Release(*ppdef);
+        else if (unix_ptr) unix_vtbl->destroy(unix_ptr);
         return hr;
     }
-    list_add_tail(&This->ff_effects, &item->entry);
-    *ppdef = item->ref;
+    unix_effect = impl_from_IDirectInputEffect(*ppdef);
+    list_add_tail(&This->ff_effects, &unix_effect->entry);
     if (pUnkOuter != NULL) FIXME("Interface aggregation not implemented.\n");
     return DI_OK;
 }
@@ -824,14 +990,14 @@ HRESULT WINAPI JoystickWGenericImpl_EnumCreatedEffectObjects(LPDIRECTINPUTDEVICE
         LPDIENUMCREATEDEFFECTOBJECTSCALLBACK lpCallback, LPVOID pvRef, DWORD dwFlags)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
-    effect_list_item *itr, *ptr;
+    struct dinput_unix_effect *itr, *ptr;
 
     TRACE("(this=%p,%p,%p,%d)\n", This, lpCallback, pvRef, dwFlags);
 
     if (!lpCallback) return DIERR_INVALIDPARAM;
     if (dwFlags != 0) FIXME("Flags specified, but no flags exist yet (DX9)!\n");
-    LIST_FOR_EACH_ENTRY_SAFE(itr, ptr, &This->ff_effects, effect_list_item, entry)
-        (*lpCallback)(itr->ref, pvRef);
+    LIST_FOR_EACH_ENTRY_SAFE(itr, ptr, &This->ff_effects, struct dinput_unix_effect, entry)
+        (*lpCallback)(IDirectInputEffect_from_impl(itr), pvRef);
     return DI_OK;
 }
 
@@ -848,7 +1014,7 @@ HRESULT WINAPI JoystickWGenericImpl_GetForceFeedbackState(LPDIRECTINPUTDEVICE8W
 HRESULT WINAPI JoystickWGenericImpl_SendForceFeedbackCommand(LPDIRECTINPUTDEVICE8W iface, DWORD dwFlags)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
-    effect_list_item *itr;
+    struct dinput_unix_effect *itr;
 
     TRACE("(this=%p,%d)\n", This, dwFlags);
 
@@ -857,14 +1023,14 @@ HRESULT WINAPI JoystickWGenericImpl_SendForceFeedbackCommand(LPDIRECTINPUTDEVICE
     switch (dwFlags)
     {
     case DISFFC_STOPALL:
-        LIST_FOR_EACH_ENTRY(itr, &This->ff_effects, effect_list_item, entry)
-            IDirectInputEffect_Stop(itr->ref);
+        LIST_FOR_EACH_ENTRY(itr, &This->ff_effects, struct dinput_unix_effect, entry)
+            IDirectInputEffect_Stop(IDirectInputEffect_from_impl(itr));
         break;
     case DISFFC_RESET:
-        LIST_FOR_EACH_ENTRY(itr, &This->ff_effects, effect_list_item, entry)
+        LIST_FOR_EACH_ENTRY(itr, &This->ff_effects, struct dinput_unix_effect, entry)
         {
-            IDirectInputEffect_Stop(itr->ref);
-            IDirectInputEffect_Unload(itr->ref);
+            IDirectInputEffect_Stop(IDirectInputEffect_from_impl(itr));
+            IDirectInputEffect_Unload(IDirectInputEffect_from_impl(itr));
         }
         break;
     default:
@@ -1204,6 +1370,8 @@ HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectI
 
     if (FAILED(hr = device->create_unix_joystick(dinput, guid, &This)))
         return hr;
+    list_init(&This->ff_effects);
+
     if (This->unix_funcs->get_mapping)
     {
         This->unix_funcs->get_mapping(This->unix_ptr, &default_axis_count, &default_axes_map);
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index f9fbffc0c0c..8ed22d5bcfc 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -87,7 +87,7 @@ struct wine_input_absinfo {
 };
 
 /* implemented in effect_linuxinput.c */
-HRESULT linuxinput_create_effect(int* fd, REFGUID rguid, struct list *parent_list_entry, LPDIRECTINPUTEFFECT* peff);
+HRESULT linuxinput_create_effect(int *fd, REFGUID rguid, DWORD type, const DIEFFECT *effect, const struct unix_effect_vtbl **vtbl, struct unix_effect **out);
 HRESULT linuxinput_get_info_A(int fd, REFGUID rguid, LPDIEFFECTINFOA info);
 
 typedef struct JoystickImpl JoystickImpl;
@@ -161,8 +161,8 @@ static HRESULT CDECL unix_joystick_ff_send_cmd(struct unix_joystick *ptr, DWORD
 
 static HRESULT CDECL unix_joystick_list_effects(struct unix_joystick *ptr, DWORD type, const GUID **guids, DWORD size, DWORD *count);
 static HRESULT CDECL unix_joystick_get_effect_info(struct unix_joystick *ptr, REFGUID guid, LPDIEFFECTINFOA diei);
-static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *effect,
-        struct list *entry, IDirectInputEffect **out);
+static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, DWORD type, const DIEFFECT *effect,
+        const struct unix_effect_vtbl **vtbl, struct unix_effect **out);
 
 static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count, BOOL *has_ff);
 static void CDECL unix_joystick_reset(struct unix_joystick *ptr);
@@ -557,7 +557,6 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
     JoystickImpl *This = impl_from_unix_joystick(ptr);
     int i, idx = 0, wine_obj;
 
-    list_init(&This->generic.ff_effects);
 #ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
     This->ff_state = FF_STATUS_STOPPED;
 #endif
@@ -820,34 +819,22 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
 /****************************************************************************** 
   *	CreateEffect - Create a new FF effect with the specified params
   */
-static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *effect,
-        struct list *entry, IDirectInputEffect **out)
+static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, DWORD type, const DIEFFECT *effect,
+        const struct unix_effect_vtbl **vtbl, struct unix_effect **out)
 {
     HRESULT retval = DI_OK;
     JoystickImpl* This = impl_from_unix_joystick(ptr);
-    TRACE("(this=%p,%p,%p,%p,%p)\n", This, guid, effect, entry, out);
+    TRACE("(this=%p,%p,%p,%p)\n", This, guid, effect, out);
 
-    *out = NULL;
     if (!This->joydev->has_ff)
     {
         TRACE("No force feedback support\n");
         return DIERR_UNSUPPORTED;
     }
 
-    retval = linuxinput_create_effect(&This->joyfd, guid, entry, out);
+    retval = linuxinput_create_effect(&This->joyfd, guid, type, effect, vtbl, out);
     if (retval != DI_OK) return retval;
 
-    if (effect != NULL)
-    {
-        retval = IDirectInputEffect_SetParameters(*out, effect,
-            DIEP_AXES | DIEP_DIRECTION | DIEP_DURATION | DIEP_ENVELOPE |
-            DIEP_GAIN | DIEP_SAMPLEPERIOD | DIEP_STARTDELAY | DIEP_TRIGGERBUTTON |
-            DIEP_TRIGGERREPEATINTERVAL | DIEP_TYPESPECIFICPARAMS);
-
-        if (retval != DI_OK && retval != DI_DOWNLOADSKIPPED)
-            return retval;
-    }
-
     return DI_OK;
 }
 
